<?php
 /*
  * TODO
 
 */

class EActsAsVersioned extends CActiveRecordBehavior
{
	public $groupByColumn = 'id' ;
	public $timestampColumn = 'created_time' ;
	
	public function afterValidate() 
	{
		$owner = $this->getOwner() ;
		if ( !$owner->getIsNewRecord() ) 
			$owner->version ++ ;
		$owner->setIsNewRecord(TRUE) ;	 // make it an INSERT
		return true ;
	}
	
	public function getCurrent($params = array()) {
		$owner = $this->getOwner() ;
		if ( isset($owner->id) )
			$params['id'] = $owner->id ;

		if ( gettype($params) == 'integer' || gettype($params) == 'string' )
				$params = array( 'id'=>$params ) ;
		
		$sql = 'SELECT * FROM (SELECT * FROM ' . $owner->tableName() . ' ORDER BY  version DESC) r1' ;
		if ( sizeof($params) > 0 )
			$sql .= ' WHERE' ; 
		$AND = '' ;
		foreach( $params as $key => $value ) {
			$sql .= ' ' . $AND ;
			if ( $key == 'before' )
				$sql .= ' ' . $this->timestampColumn . ' < :' . $key ;
			else if ( $key == 'after' )
				$sql .= ' ' . $this->timestampColumn . ' > :' . $key ;
			else
				$sql .=  ' r1.' . $key . '= :' . $key ; 
			$AND = 'AND' ;
		}
		$sql .= ' GROUP BY r1.' . $this->groupByColumn ;
		
		$command = Yii::app()->db->createCommand($sql) ;
		
		foreach( $params as $key => $value ) {
			$command->bindValue(':' .$key, $value);	
		}
		
		$models = $command->queryAll() ;
		if ( sizeof($models) > 0 ) {
			if ( isset($params['id']) ) { // return a model
				return $owner->populateRecord($models[0]) ;
			}
			else // return an array of models
				return $owner->populateRecords($models) ;
		}
		return NULL ;
	}
	
	public function getVersions() {
		$owner = $this->getOwner() ;	
		
		$sql = 'SELECT version FROM ' . $owner->tableName() . ' ORDER BY version ASC' ;
		return Yii::app()->db->createCommand($sql)->queryAll() ;
	}
	
	public function getVersion($params) {
			if ( gettype($params) == 'integer' || gettype($params) == 'string' ) // it is a version number
				$params = array( 'version'=>$params ) ;
			return $this->getCurrent($params) ;
	}
}